unit Keyboard;{(C) 1995-97 Ruslan Fazliev}
              {2:5051/13.12@fidonet}
              {FREEWARE}
              {Any modifies to this source are prohibitted by author}
              {Credit me in your program}
{Version 1.20}
interface
uses DOS;
const
NewKbdHandler:boolean=false;{Example:
                                     ...
                                     uses Keyboard;
                                     ...
                                     if NewKbdHandler then
                                       RestoreKeyboard;
                                     Read(d);
                                     ...}

{ Warning : use RestoreKeyboard before any attempt to read keyboard using
ReadKey or Readln , example :

...

InitKeyboard

...

RestoreKeyboard;
Readln(v);
InitKeyboard;
if ScanData[1] then Exit;

...

Don't forget to call RestoreKeyboard before quit : 

...
RestoreKeyboard;
end.

}
KbdId:string=#13#10'BPC Keyboard, Copyright (C) 1995-97 Ruslan Fazliev.'#13#10;
var
ScanData:array[0..127] of boolean;{Example:
                                           ...
                                           uses Keyboard;
                                           ...
                                           if ScanData[$48] then ...
                                           ...
                                  }
LastScan:byte;

procedure InitKeyboard;
{Installs new keyboard IRQ handler}
procedure RestoreKeyboard;
{Restores old keyboard IRQ handler}
function GetKey:char;
function WaitKey:char;
implementation
var
OldVector:pointer;
OldExitProc:pointer;
i:byte;
type
  PChar=^TChar;
  TChar=array[0..127] of char;
const
  KeyCodes:TChar =
    (
    #255,#27,'1','2','3','4','5','6','7','8','9','0','-','=',#8,#9,'q','w','e','r',
    't','y','u','i','o','p','[',']',#13,#255,'a','s','d','f','g','h','j','k',
    'l',';','''','`',#255,'\','z','x','c','v','b','n','m',',','.','/',#255,
    '*',#255,' ',
    #255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    '-',#255,#255,#255,'+',#255,#255,#255,#255,#255,#255,#13,'/',
    #255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    #255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    #255,#255,#255,#255,#255,#255,#255,#255,#255);
  ShiftedCodes:TChar =
    (
    #255,#255,'!','@','#','$','%','^','&','*','(',')','_','+',#255,#255,'Q',
    'W','E','R','T','Y','U','I','O','P','{','}',#255,#255,'A','S','D','F','G',
    'H','J','K','L',':','"','~',#255,'|','Z','X','C','V','B','N','M','<','>',
    '?',#255,'*',#255,' ',#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    #255,#255,#255,#255,#255,#255,'-',#255,#255,#255,'+',#255,#255,#255,#255,
    #255,#255,#13,'/',
    #255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    #255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,#255,
    #255,#255,#255,#255,#255,#255,#255,#255,#255);

{$F+}
procedure NewExitProc;
begin
  ExitProc:=OldExitProc;
  RestoreKeyboard;
end;
{$F-}
procedure Int9Handler;assembler;
asm
  push ax
  push bx
  push ds
  in   al,60h
  xor  ah,ah
  mov  bx,seg ScanData
  mov  ds,bx
  test al,80h
  jnz  @Release
  mov  ah,1
  mov  LastScan,al
@Release:
  and  al,7Fh
  lea  bx,ScanData
  add  bl,al
  adc  bh,0
  mov  [bx],ah
  in   al,61h
  mov  ah,al
  or   al,80h
  out  61h,al
  mov  al,ah
  out  61h,al
  mov  al,20h
  out  20h,al
  pop  ds
  pop  bx
  pop  ax
  iret
end;
procedure InitKeyboard;
begin
if NewKbdHandler then exit;
LastScan:=$FF;
Port[$61]:=Port[$61] and $7F;
GetIntVec(9,OldVector);
SetIntVec(9,@Int9Handler);
Port[$61]:=Port[$61] or $80;
NewKbdHandler:=true;
end;
procedure RestoreKeyboard;
begin
if not NewKbdHandler then exit;
Port[$61]:=Port[$61] and $7F;
SetIntVec(9,OldVector);
Port[$61]:=Port[$61] or $80;
NewKbdHandler:=false;
end;
function GetKey:char;
var
  i:byte;
  p:PChar;
  gk:char;
begin
  if ScanData[$2A] or ScanData[$36] then
    p:=@ShiftedCodes
  else
    p:=@KeyCodes;
  for i:=0 to 127 do
    if ScanData[i] then
    begin
      GK:=p^[i];
      if GK<>#255 then
      begin
        GetKey:=gk;
        Exit;
      end;
    end;
  GetKey:=#255;
end;
function WaitKey:char;
var
  p:PChar;
  gk:char;
begin
  repeat
    LastScan:=$FF;
    while LastScan=$FF do
      ;
    if ScanData[$2A] or ScanData[$36] then
      p:=@ShiftedCodes
    else
      p:=@KeyCodes;
    GK:=p^[LastScan];
  until GK<>#255;
  WaitKey:=GK;
end;
begin
for i:=0 to 127 do ScanData[i]:=false;
OldExitProc:=ExitProc;
ExitProc:=@NewExitProc;
end.